Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2918)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2920)
@@ -2302,4 +2296,12 @@
           CALL message( 'check_parameters', 'PA0592', 1, 2, 0, 6, 0 )
        ENDIF
+!
+!--    naheatlayers
+       IF ( naheatlayers > nzt )  THEN
+          message_string = 'number of anthropogenic heat layers '//            &
+                           '"naheatlayers" can not be larger than'//           &
+                           ' number of domain layers "nzt"'
+          CALL message( 'check_parameters', 'PA0593', 1, 2, 0, 6, 0 )
+       ENDIF
 
     END SUBROUTINE usm_check_parameters
@@ -2331,8 +2333,10 @@
         INTEGER(iwp), PARAMETER                                :: nd = 5
         CHARACTER(len=6), DIMENSION(0:nd-1), PARAMETER         :: dirname = (/ '_roof ', '_south', '_north', '_west ', '_east ' /)
-        INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER             :: dirint = (/ iup_u, isouth_u, inorth_u, iwest_u, ieast_u /)
+        INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER             :: dirint =  (/    iup_u, isouth_u, inorth_u,  iwest_u,  ieast_u /)
+        INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER             :: diridx =  (/       -1,        1,        0,        3,        2 /)
+                                                                     !< index for surf_*_v: 0:3 = (North, South, East, West)
         INTEGER(iwp), DIMENSION(0:nd-1)                        :: dirstart
         INTEGER(iwp), DIMENSION(0:nd-1)                        :: dirend
-        INTEGER(iwp)                                           :: ids,isurf,isvf,isurfs,isurflt
+        INTEGER(iwp)                                           :: ids,idsint,idsidx,isurf,isvf,isurfs,isurflt
         INTEGER(iwp)                                           :: is,js,ks,i,j,k,iwl,istat, l, m
         INTEGER(iwp)                                           ::  k_topo    !< topography top index
@@ -2351,4 +2355,6 @@
             IF ( var(k-j+1:k) == dirname(i) )  THEN
                 ids = i
+                idsint = dirint(ids)
+                idsidx = diridx(ids)
                 var = var(:k-j)
                 EXIT
@@ -2400,11 +2406,13 @@
           CASE ( 'usm_surfz' )
 !--           array of lw radiation falling to local surface after i-th reflection
-              DO  m = 1, surf_usm_h%ns
-                 i = surf_usm_h%i(m)
-                 j = surf_usm_h%j(m)
-                 k = surf_usm_h%k(m)
-                 temp_pf(0,j,i) = MAX( temp_pf(0,j,i), REAL( k, kind=wp) )
-              ENDDO
-              DO  l = 0, 3
+              IF ( idsint == iup_u )  THEN
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(0,j,i) = MAX( temp_pf(0,j,i), REAL( k, kind=wp) )
+                 ENDDO
+              ELSE
+                 l = idsidx
                  DO  m = 1, surf_usm_v(l)%ns
                     i = surf_usm_v(l)%i(m)
@@ -2413,15 +2421,17 @@
                     temp_pf(0,j,i) = MAX( temp_pf(0,j,i), REAL( k, kind=wp) + 1.0_wp )
                  ENDDO
-              ENDDO
+              ENDIF
 
           CASE ( 'usm_surfcat' )
 !--           surface category
-              DO  m = 1, surf_usm_h%ns
-                 i = surf_usm_h%i(m)
-                 j = surf_usm_h%j(m)
-                 k = surf_usm_h%k(m)
-                 temp_pf(k,j,i) = surf_usm_h%surface_types(m)
-              ENDDO
-              DO  l = 0, 3
+              IF ( idsint == iup_u )  THEN
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = surf_usm_h%surface_types(m)
+                 ENDDO
+              ELSE
+                 l = idsidx
                  DO  m = 1, surf_usm_v(l)%ns
                     i = surf_usm_v(l)%i(m)
@@ -2430,20 +2440,22 @@
                     temp_pf(k,j,i) = surf_usm_v(l)%surface_types(m)
                  ENDDO
-              ENDDO
+              ENDIF
               
           CASE ( 'usm_surfalb' )
 !--           surface albedo, weighted average
-              DO  m = 1, surf_usm_h%ns
-                 i = surf_usm_h%i(m)
-                 j = surf_usm_h%j(m)
-                 k = surf_usm_h%k(m)
-                 temp_pf(k,j,i) = surf_usm_h%frac(0,m)     *                   &
-                                  surf_usm_h%albedo(0,m) +                     &
-                                  surf_usm_h%frac(1,m)     *                   &
-                                  surf_usm_h%albedo(1,m) +                     &
-                                  surf_usm_h%frac(2,m)     *                   &
-                                  surf_usm_h%albedo(2,m)
-              ENDDO
-              DO  l = 0, 3
+              IF ( idsint == iup_u )  THEN
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = surf_usm_h%frac(0,m)     *                   &
+                                     surf_usm_h%albedo(0,m) +                     &
+                                     surf_usm_h%frac(1,m)     *                   &
+                                     surf_usm_h%albedo(1,m) +                     &
+                                     surf_usm_h%frac(2,m)     *                   &
+                                     surf_usm_h%albedo(2,m)
+                 ENDDO
+              ELSE
+                 l = idsidx
                  DO  m = 1, surf_usm_v(l)%ns
                     i = surf_usm_v(l)%i(m)
@@ -2457,20 +2469,22 @@
                                      surf_usm_v(l)%albedo(2,m)
                  ENDDO
-              ENDDO
+              ENDIF
               
           CASE ( 'usm_surfemis' )
 !--           surface emissivity, weighted average
-              DO  m = 1, surf_usm_h%ns
-                 i = surf_usm_h%i(m)
-                 j = surf_usm_h%j(m)
-                 k = surf_usm_h%k(m)
-                 temp_pf(k,j,i) =  surf_usm_h%frac(0,m)     *                  &
-                                   surf_usm_h%emissivity(0,m) +                &
-                                   surf_usm_h%frac(1,m)     *                  &
-                                   surf_usm_h%emissivity(1,m) +                &
-                                   surf_usm_h%frac(2,m)     *                  &
-                                   surf_usm_h%emissivity(2,m)
-              ENDDO
-              DO  l = 0, 3
+              IF ( idsint == iup_u )  THEN
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) =  surf_usm_h%frac(0,m)     *                  &
+                                      surf_usm_h%emissivity(0,m) +                &
+                                      surf_usm_h%frac(1,m)     *                  &
+                                      surf_usm_h%emissivity(1,m) +                &
+                                      surf_usm_h%frac(2,m)     *                  &
+                                      surf_usm_h%emissivity(2,m)
+                 ENDDO
+              ELSE
+                 l = idsidx
                  DO  m = 1, surf_usm_v(l)%ns
                     i = surf_usm_v(l)%i(m)
@@ -2484,15 +2498,17 @@
                                      surf_usm_v(l)%emissivity(2,m)
                  ENDDO
-              ENDDO
+              ENDIF
 
           CASE ( 'usm_surfwintrans' )
 !--           transmissivity window tiles
-              DO  m = 1, surf_usm_h%ns
-                 i = surf_usm_h%i(m)
-                 j = surf_usm_h%j(m)
-                 k = surf_usm_h%k(m)
-                 temp_pf(k,j,i) = surf_usm_h%transmissivity(m)
-              ENDDO
-              DO  l = 0, 3
+              IF ( idsint == iup_u )  THEN
+                 DO  m = 1, surf_usm_h%ns
+                    i = surf_usm_h%i(m)
+                    j = surf_usm_h%j(m)
+                    k = surf_usm_h%k(m)
+                    temp_pf(k,j,i) = surf_usm_h%transmissivity(m)
+                 ENDDO
+              ELSE
+                 l = idsidx
                  DO  m = 1, surf_usm_v(l)%ns
                     i = surf_usm_v(l)%i(m)
@@ -2501,5 +2517,20 @@
                     temp_pf(k,j,i) = surf_usm_v(l)%transmissivity(m)
                  ENDDO
-
+              ENDIF
+
+          CASE ( 'usm_skyvf' )
+!--           sky view factor
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == idsint )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = skyvf(isurf)
+                 ENDIF
+              ENDDO
+              
+          CASE ( 'usm_skyvft' )
+!--           sky view factor
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == ids )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = skyvft(isurf)
+                 ENDIF
               ENDDO
 
@@ -2518,5 +2549,5 @@
                              
                   IF ( surf(ix,isurfs) == is  .AND.  surf(iy,isurfs) == js  .AND.       &
-                       surf(iz,isurfs) == ks  .AND.  surf(id,isurfs) == ids )  THEN
+                       surf(iz,isurfs) == ks  .AND.  surf(id,isurfs) == idsint )  THEN
   !--                 correct source surface
                       temp_pf(surfl(iz,isurflt),surfl(iy,isurflt),surfl(ix,isurflt)) = svf(k,isvf)
@@ -2527,11 +2558,13 @@
 !--           array of complete radiation balance
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%rad_net_l(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%rad_net_l(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2540,13 +2573,15 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%rad_net_l(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%rad_net_av(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%rad_net_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2555,5 +2590,5 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%rad_net_av(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ENDIF
 
@@ -2561,5 +2596,5 @@
 !--           array of sw radiation falling to surface after i-th reflection
               DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
+                 IF ( surfl(id,isurf) == idsint )  THEN
                    IF ( av == 0 )  THEN
                      temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinsw(isurf)
@@ -2573,5 +2608,5 @@
 !--           array of lw radiation falling to surface after i-th reflection
               DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
+                 IF ( surfl(id,isurf) == idsint )  THEN
                    IF ( av == 0 )  THEN
                      temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinlw(isurf)
@@ -2585,5 +2620,5 @@
 !--           array of direct sw radiation falling to surface from sun
               DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
+                 IF ( surfl(id,isurf) == idsint )  THEN
                    IF ( av == 0 )  THEN
                      temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinswdir(isurf)
@@ -2597,5 +2632,5 @@
 !--           array of difusion sw radiation falling to surface from sky and borders of the domain
               DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
+                 IF ( surfl(id,isurf) == idsint )  THEN
                    IF ( av == 0 )  THEN
                      temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinswdif(isurf)
@@ -2609,5 +2644,5 @@
 !--           array of sw radiation falling to surface from reflections
               DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
+                 IF ( surfl(id,isurf) == idsint )  THEN
                    IF ( av == 0 )  THEN
                      temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = &
@@ -2619,8 +2654,20 @@
               ENDDO
 
+          CASE ( 'usm_rad_inlwdif' )
+!--           array of difusion lw radiation falling to surface from sky and borders of the domain
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == idsint )  THEN
+                   IF ( av == 0 )  THEN
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinlwdif(isurf)
+                   ELSE
+                     temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinlwdif_av(isurf)
+                   ENDIF
+                 ENDIF
+              ENDDO
+
           CASE ( 'usm_rad_inlwref' )
 !--           array of lw radiation falling to surface from reflections
               DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
+                 IF ( surfl(id,isurf) == idsint )  THEN
                    IF ( av == 0 )  THEN
                      temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinlw(isurf) - surfinlwdif(isurf)
@@ -2634,5 +2681,5 @@
 !--           array of sw radiation emitted from surface after i-th reflection
               DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
+                 IF ( surfl(id,isurf) == idsint )  THEN
                    IF ( av == 0 )  THEN
                      temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfoutsw(isurf)
@@ -2646,5 +2693,5 @@
 !--           array of lw radiation emitted from surface after i-th reflection
               DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
+                 IF ( surfl(id,isurf) == idsint )  THEN
                    IF ( av == 0 )  THEN
                      temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfoutlw(isurf)
@@ -2658,5 +2705,5 @@
 !--           average of array of residua of sw radiation absorbed in surface after last reflection
               DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
+                 IF ( surfl(id,isurf) == idsint )  THEN
                    IF ( av == 0 )  THEN
                      temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfins(isurf)
@@ -2670,5 +2717,5 @@
 !--           average of array of residua of lw radiation absorbed in surface after last reflection
               DO isurf = dirstart(ids), dirend(ids)
-                 IF ( surfl(id,isurf) == ids )  THEN
+                 IF ( surfl(id,isurf) == idsint )  THEN
                    IF ( av == 0 )  THEN
                      temp_pf(surfl(iz,isurf),surfl(iy,isurf),surfl(ix,isurf)) = surfinl(isurf)
@@ -2682,11 +2729,13 @@
 !--           array of heat flux from radiation for surfaces after all reflections
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%surfhf(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%surfhf(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2695,13 +2744,15 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%surfhf(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%surfhf_av(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%surfhf_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2710,5 +2761,5 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%surfhf_av(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ENDIF
  
@@ -2716,11 +2767,13 @@
 !--           array of sensible heat flux from surfaces
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%wshf_eb(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%wshf_eb(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2729,13 +2782,15 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%wshf_eb(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%wshf_eb_av(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%wshf_eb_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2744,5 +2799,5 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%wshf_eb_av(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ENDIF
 
@@ -2751,11 +2806,13 @@
 !--           array of heat flux from ground (land, wall, roof)
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%wghf_eb(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%wghf_eb(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2764,13 +2821,15 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%wghf_eb(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%wghf_eb_av(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%wghf_eb_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2779,5 +2838,5 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%wghf_eb_av(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ENDIF
 
@@ -2786,11 +2845,13 @@
 
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%wghf_eb_window(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%wghf_eb_window(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2799,13 +2860,15 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%wghf_eb_window(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%wghf_eb_window_av(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%wghf_eb_window_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2814,5 +2877,5 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%wghf_eb_window_av(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ENDIF
 
@@ -2821,11 +2884,13 @@
 
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%wghf_eb_green(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%wghf_eb_green(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2834,13 +2899,15 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%wghf_eb_green(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%wghf_eb_green_av(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%wghf_eb_green_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2849,5 +2916,5 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%wghf_eb_green_av(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ENDIF
 
@@ -2855,11 +2922,13 @@
 !--           array of heat flux from indoor ground (land, wall, roof)
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%iwghf_eb(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%iwghf_eb(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2868,13 +2937,15 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%iwghf_eb(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%iwghf_eb_av(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%iwghf_eb_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2883,5 +2954,5 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%iwghf_eb_av(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ENDIF
 
@@ -2890,11 +2961,13 @@
 
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%iwghf_eb_window(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%iwghf_eb_window(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2903,13 +2976,15 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%iwghf_eb_window(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ELSE
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = surf_usm_h%iwghf_eb_window_av(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = surf_usm_h%iwghf_eb_window_av(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
@@ -2918,5 +2993,5 @@
                        temp_pf(k,j,i) = surf_usm_v(l)%iwghf_eb_window_av(m)
                     ENDDO
-                 ENDDO
+                 ENDIF
               ENDIF
               
@@ -2924,11 +2999,13 @@
 !--           surface temperature for surfaces
               IF ( av == 0 )  THEN
-                 DO  m = 1, surf_usm_h%ns
-                    i = surf_usm_h%i(m)
-                    j = surf_usm_h%j(m)
-                    k = surf_usm_h%k(m)
-                    temp_pf(k,j,i) = t_surf_h(m)
-                 ENDDO
-                 DO  l = 0, 3
+                 IF ( idsint == iup_u )  THEN
+                    DO  m = 1, surf_usm_h%ns
+                       i = surf_usm_h%i(m)
+                       j = surf_usm_h%j(m)
+                       k = surf_usm_h%k(m)
+                       temp_pf(k,j,i) = t_surf_h(m)
+                    ENDDO
+                 ELSE
+                    l = idsidx
                     DO  m = 1, surf_usm_v(l)%ns
                        i = surf_usm_v(l)%i(m)
